<?php
include_once('class.database.php');
class ManageClasses
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddClass($clcode,$clname,$capacity,$claddress,$clcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("INSERT INTO `".$prefix."classes` (`clcode`,`clname`,`capacity`,`claddress`,`clcomment`,`admin_id`)
		VALUES (?,?,?,?,?,?)
		");
		$values = array($clcode,$clname,$capacity,$claddress,$clcomment,$admin_id);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateClass($clid,$clcode,$clname,$capacity,$claddress,$clcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE ".$prefix."classes SET `clcode`=?, `clname`=?, `capacity`=?,`claddress`=?, `clcomment`=?, `admin_id`=? WHERE `clid`=?");
		$values = array($clcode,$clname,$capacity,$claddress,$clcomment,$admin_id,$clid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function GetClassList($query)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."classes` $query ORDER BY `clid` DESC");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	function GetClassList2($query,$start,$limit)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."classes` $query ORDER BY `clid` DESC LIMIT $start,$limit");
		$counts = $query->rowCount();

		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetClassInfo($clcode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."classes` WHERE `clcode`=?");
		$values = array($clcode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function ClCodeAvailability($clcode)
	{
		global $prefix;
		if(preg_match('/^[a-z\d_]{1,50}$/i', $clcode))
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."classes` WHERE `clcode`=?");
			$values = array($clcode);
			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 0;			
			else
				return 1;
		}
		else
		{
			return 2;
		}
		
	}
	
	function GetClassInfoById($clid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."classes` WHERE `clid`=?");
		$values = array($clid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastClassID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `clid` FROM `".$prefix."classes` ORDER BY `clid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['clid'];	
	}
	
	function DeleteClass($clid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."classes` WHERE `clid`=?");
		$values = array($clid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;
	}
	
}

?>
