<?php
include_once('class.database.php');
class ManageCourseStudents
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddCourseStudent($sid,$cid,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT count(*) AS `count` FROM `".$prefix."course_student` WHERE `cid`=?");
		$values = array($cid);
		$query->execute($values);
		$result = $query->fetchAll();
		$num_of_students_in_this_course = $result[0]['count'];
		$query = $this->link->prepare("SELECT `final_capacity` FROM `".$prefix."courses` WHERE `cid`=?");
		$values = array($cid);
		$query->execute($values);
		$result = $query->fetchAll();
		$final_capacity = $result[0]['final_capacity'];
		if($num_of_students_in_this_course>=$final_capacity)
			return 10;
		else
		{
			$query = $this->link->prepare("INSERT INTO `".$prefix."course_student` (`sid` ,`cid`,`admin_id`)
			VALUES (?,?,?)");
			$values = array($sid,$cid,$admin_id);
			$query->execute($values);
			$counts = $query->rowCount();
			
			return $counts;
		}
	}
	
	function UpdateCourseStudent($csid,$ccode,$scode,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT `cid` FROM `".$prefix."courses` WHERE `ccode`=?");
		$values = array($ccode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==0)
		{
			return 1;
		}
		else
		{
			$result = $query->fetchAll();
			$cid = $result[0]['cid'];
		}
		
		$query = $this->link->prepare("SELECT sid FROM `".$prefix."students` WHERE `scode`=?");
		$values = array($scode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==0)
		{
			return 2;
		}
		else
		{
			$result = $query->fetchAll();
			$sid = $result[0]['sid'];
		}
		
		$query = $this->link->prepare("UPDATE `".$prefix."course_student` SET `sid`=?, `cid`=?, `admin_id`=? WHERE `csid`=?");
		$values = array($sid,$cid,$admin_id,$csid);

		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==0)
			return 3;
		else
		return 4;
	}
	
	function GetCourseStudentList($query,$order)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` $query $order");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetCourseStudentList2($query,$order,$start,$limit)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` $query $order LIMIT $start,$limit");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	
	function GetCourseStudentInfo($ccode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `ccode`=?");
		$values = array($ccode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function GetCourseStudentInfoById($csid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `csid`=?");
		$values = array($csid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastCourseStudentID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `cid` FROM `".$prefix."course_student` ORDER BY `cid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['cid'];	
	}
	
	function DeleteCourseStudent($csid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."course_student` WHERE `csid`=?");
		$values = array($csid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
	function addScore($csid,$grade,$grade_status,$exam_status,$cscomment,$admin_id)
	{
		global $prefix;
		if($grade>20)
			return 0;
		if($admin_id=="")
		{
			$query = $this->link->prepare("UPDATE `".$prefix."course_student` SET `grade`=?, `grade_status`=?, `exam_status`=?, `cscomment`=? WHERE `csid`=?");
			$values = array($grade,$grade_status,$exam_status,$cscomment,$csid);			
		}
		else
		{	
			$query = $this->link->prepare("UPDATE ".$prefix."course_student SET `grade`=?, `grade_status`=?, `exam_status`=?, `cscomment`=?, `admin_id`=? WHERE `csid`=?");
			$values = array($grade,$grade_status,$exam_status,$cscomment,$admin_id,$csid);
		}


		$query->execute($values);
		$counts = $query->rowCount();
		//print_r($query->errorInfo());
		return $counts;
	}
	
	function UpdateChair($csid,$chair_number,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."course_student` SET `chair_number`=?, `admin_id`=? WHERE `csid`=?");
		$values = array($chair_number,$admin_id,$csid);

		$query->execute($values);
		$counts = $query->rowCount();
		return $counts;
	}
	
	function CalculateAve($tid,$sid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT sum(`grade`*`factor`)/sum(`factor`) AS `ave` FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `".$prefix."course_student`.`sid`=? AND `".$prefix."terms`.`tid`=? AND `".$prefix."lessons`.`eff_on_term_avg`!=0 AND `grade`!='' ORDER BY `".$prefix."lessons`.`lname`");
		$values = array($sid,$tid);
		$query->execute($values);

		$result = $query->fetchAll();
		
		return round($result[0]['ave'],2);			
		
	}
	
	function UpdateObjectionStatus($csid,$ostatus)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."objections` SET `ostatus`=?  WHERE `csid`=?");
		$values = array($ostatus,$csid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateObjection($cid,$objection)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE ".$prefix."courses SET `objection`=?  WHERE `cid`=?");
		$values = array($objection,$cid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	function GetCourseObjections($cid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."objections` INNER JOIN `".$prefix."course_student` ON `".$prefix."objections`.`csid`=`".$prefix."course_student`.`csid` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` WHERE `".$prefix."courses`.`cid`=?AND `".$prefix."objections`.`ostatus`=1 ORDER BY `".$prefix."objections`.`oid` DESC");
		$values = array($cid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
}

?>
