<?php
include_once('class.database.php');
class ManageCourses
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddCourse($ccode,$tid,$lid,$pid,$clid,$final_capacity,$days_times,$exam_date,$exam_place,$ccomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("INSERT INTO `".$prefix."courses` (`ccode` ,`tid` ,`lid` ,`pid` ,`clid` ,`final_capacity` ,`days_times` ,`exam_date` ,`exam_place` ,`ccomment` ,`admin_id`)
		VALUES (?,?,?,?,?,?,?,?,?,?,?)
		");
		$values = array($ccode,$tid,$lid,$pid,$clid,$final_capacity,$days_times,$exam_date,$exam_place,$ccomment,$admin_id);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateCourse($cid,$ccode,$tid,$lid,$pid,$clid,$final_capacity,$days_times,$exam_date,$exam_place,$ccomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."courses` SET `ccode`=?, `tid`=?, `lid`=?,`pid`=?, `clid`=?, `final_capacity`=?, `days_times`=?, `exam_date`=?, `exam_place`=?, `ccomment`=?, `admin_id`=? WHERE `cid`=?");
		$values = array($ccode,$tid,$lid,$pid,$clid,$final_capacity,$days_times,$exam_date,$exam_place,$ccomment,$admin_id,$cid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateObjection($cid,$objection)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."courses` SET `objection`=?  WHERE `cid`=?");
		$values = array($objection,$cid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function GetCourseList($query)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."courses` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` $query ORDER BY `".$prefix."courses`.`cid` DESC");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetCourseList2($query,$start,$limit)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."courses` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` $query ORDER BY `".$prefix."courses`.`cid` DESC LIMIT $start,$limit");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	
	function GetCourseInfo($ccode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."courses` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` WHERE ccode=?");
		$values = array($ccode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function CCodeAvailability($ccode)
	{
		global $prefix;
		if(preg_match('/^[a-z\d_]{1,50}$/i', $ccode))
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."courses` WHERE `ccode`=?");
			$values = array($ccode);
			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 0;			
			else
				return 1;
		}
		else
		{
			return 2;
		}
		
	}
	
	function GetCourseInfoById($cid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."courses` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` WHERE `cid`=?");
		$values = array($cid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastCourseID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `cid` FROM `".$prefix."courses` ORDER BY `cid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['cid'];	
	}
	
	function DeleteCourse($cid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."courses` WHERE `cid`=?");
		$values = array($cid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
}
?>
