<?php
include_once('class.database.php');
class ManageHomeworks
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddHomework($csid,$cid,$htitle,$hdescription,$hfinal_date,$hextensions,$hfinal_size)
	{
		global $prefix;
		$hextensions = str_replace(' ','',$hextensions);
		$query = $this->link->prepare("INSERT INTO `".$prefix."homeworks` (`csid`,`cid`,`htitle`,`hdescription`,`hadded_date`,`hfinal_date`,`hextensions`,`hfinal_size`)
		VALUES (?,?,?,?,NOW(),?,?,?)
		");
		$values = array($csid,$cid,$htitle,$hdescription,$hfinal_date,$hextensions,$hfinal_size);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}

	function DoHomework($hid,$csid,$file_name,$hddescription)
	{
		global $prefix;
		$hextensions = str_replace(' ','',$hextensions);
		$query = $this->link->prepare("INSERT INTO `".$prefix."homeworks_done` (`hid`,`csid`,`file_name`,`hddate`,`hddescription`,`hdstatus`)
		VALUES (?,?,?,NOW(),?,0)
		");
		$values = array($hid,$csid,$file_name,$hddescription);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}

	function DoHomework2($hid,$csid,$file_name,$hddescription)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."homeworks_done` SET `file_name`=?, `hddescription`=?, `hddate`=NOW(), `hdstatus`=0 WHERE `hid`=? AND `csid`=?");
		$values = array($file_name,$hddescription,$hid,$csid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function GetHomeworkInfo($hid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE `hid`=?");
		$values = array($hid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function GetHomeworkDoneInfo($hid,$csid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks_done` WHERE `hid`=? AND `csid`=?");
		$values = array($hid,$csid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function DeleteHomework($hid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT `file_name` FROM `".$prefix."homeworks_done` WHERE `hid`=?");
		$values = array($hid);
		$query->execute($values);
		$result = $query->fetchAll();
		foreach($result as $file_name)
		{
			if(file_exists('../homework/'.$file_name['file_name']))
				unlink('../homework/'.$file_name['file_name']);
			
			if(file_exists('homework/'.$file_name['file_name']))
				unlink('homework/'.$file_name['file_name']);
		}
		
		$query = $this->link->prepare("DELETE FROM `".$prefix."homeworks` WHERE `hid`=?");
		$values = array($hid);
		$query->execute($values);
		$counts = $query->rowCount();
		
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
	function UpdateHomework($hid,$htitle,$hdescription,$hfinal_date,$hextensions,$hfinal_size)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."homeworks` SET `htitle`=?, `hdescription`=?, `hfinal_date`=?, `hextensions`=?, `hfinal_size`=? WHERE `hid`=?");
		$values = array($htitle,$hdescription,$hfinal_date,$hextensions,$hfinal_size,$hid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function HomeworksList($cid,$csid,$hdstatus)
	{
		global $prefix;
		switch($hdstatus)
		{
			case 0: //undone
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE (`cid`=? OR `csid`=?) AND `hid` NOT IN (SELECT `hid` FROM `".$prefix."homeworks_done` WHERE `csid`='$csid') ORDER BY `hid` DESC");
				$values = array($cid,$csid);
				$query->execute($values);
			break;
			
			case 1: //accepted
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks_done` INNER JOIN `".$prefix."homeworks` ON `".$prefix."homeworks_done`.`hid`=`".$prefix."homeworks`.`hid` WHERE `".$prefix."homeworks_done`.`csid`=? AND `hdstatus`='1' ORDER BY `".$prefix."homeworks_done`.`hid` DESC");
				$values = array($csid);
				$query->execute($values);
			break;
			
			case 2: //rejected
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks_done` INNER JOIN `".$prefix."homeworks` ON `".$prefix."homeworks_done`.`hid`=`".$prefix."homeworks`.`hid` WHERE `".$prefix."homeworks_done`.`csid`=? AND (`hdstatus`='2' OR `hdstatus`=6) ORDER BY `".$prefix."homeworks_done`.`hid` DESC");
				$values = array($csid);
				$query->execute($values);
			break;
			
			case 3: //time_finished
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE (`cid`=? OR `csid`=?) AND `hfinal_date`<NOW() AND `hid` NOT IN (SELECT `hid` FROM `".$prefix."homeworks_done` WHERE `csid`='$csid') ORDER BY `hid` DESC");
				$values = array($cid,$csid);
				$query->execute($values);
			break;
			
			case 9: //done
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks_done` INNER JOIN `".$prefix."homeworks` ON `".$prefix."homeworks_done`.`hid`=`".$prefix."homeworks`.`hid` WHERE `".$prefix."homeworks_done`.`csid`=? ORDER BY `".$prefix."homeworks_done`.`hid` DESC");
				$values = array($csid);
				$query->execute($values);				
			break;
			
			case 5: //Not-Checked
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks_done` INNER JOIN `".$prefix."homeworks` ON `".$prefix."homeworks_done`.`hid`=`".$prefix."homeworks`.`hid` WHERE `".$prefix."homeworks_done`.`csid`=? AND `hdstatus`=0 ORDER BY `".$prefix."homeworks_done`.`hid` DESC");
				$values = array($csid);
				$query->execute($values);
			break;
			
			case 10: //total
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE `cid`=? OR `csid`=? ORDER BY `hid` DESC");
				$values = array($cid,$csid);
				$query->execute($values);
			break;
		}
		
		$result = $query->fetchAll();
		return $result;			
		
	}
	
	function GetHomeworkStatus($hid,$csid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks_done` WHERE `hid`=? AND `csid`=?");
		$values = array($hid,$csid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==0)
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE `hid`=?");
			$values = array($hid);
			$query->execute($values);
			$result = $query->fetchAll();
			if($result[0]['hfinal_date']<date("Y-m-d"))
				return 3;//time-finished
			else
				return 9; //undone
		}
		else
		{
			$result = $query->fetchAll();
			return $result[0]['hdstatus'];//0:not_checked 1:accepted 2:rejected 3:time_finnished 6:resend
		}
	}
	
	function TeacherAccessCheck($op,$id,$pcode)
	{
		global $prefix;
		switch($op)
		{
		
			case "cid":
				$query = $this->link->prepare("SELECT * FROM `".$prefix."courses` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` WHERE `cid`=? AND `".$prefix."teachers`.`pcode`=?");
				$values = array($id,$pcode);
				$query->execute($values);
			break;
			case "csid":
				$query = $this->link->prepare("SELECT * FROM `".$prefix."course_student` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` WHERE `csid`=? AND `".$prefix."teachers`.`pcode`=?");
				$values = array($id,$pcode);
				$query->execute($values);
			break;
			case "hid":
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE `hid`=?");
				$values = array($id);
				$query->execute($values);
				$result = $query->fetchAll();
				if($result[0]['cid']==NULL)
				{
					$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` INNER JOIN `".$prefix."course_student` ON `".$prefix."homeworks`.`csid`= `".$prefix."course_student`.`csid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` WHERE `".$prefix."homeworks`.`hid`=? AND `".$prefix."teachers`.`pcode`=?");
					$values = array($id,$pcode);
					$query->execute($values);
				}
				else if($result[0]['csid']==NULL)
				{
					$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` INNER JOIN `".$prefix."courses` ON `".$prefix."homeworks`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` WHERE `".$prefix."homeworks`.`hid`=? AND `".$prefix."teachers`.`pcode`=?");
					$values = array($id,$pcode);
					$query->execute($values);
				}
			break;
		}
		$counts = $query->rowCount();
		if($counts==0)
			return 0; //No Access
		else
			return 1;
	}
	
	function CheckStudentPermission($csid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT `admin_level` FROM `".$prefix."homeworks_admins` WHERE `csid`=?");
		$values = array($csid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==0)
			return 0;
		else
		{
			$result = $query->fetchAll();
			return $result[0]['admin_level'];
		}
	}
	
	function StudentAccessCheck($op,$id,$scode)
	{
		global $prefix;
		switch($op)
		{
			case "cid":
				$query = $this->link->prepare("SELECT `admin_level` FROM `".$prefix."homeworks_admins` INNER JOIN `".$prefix."course_student` ON `".$prefix."homeworks_admins`.`csid`=`".$prefix."course_student`.`csid` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` WHERE `".$prefix."course_student`.`cid`=? AND `".$prefix."students`.`scode`=?");
				$values = array($id,$scode);
				$query->execute($values);
			break;
			case "csid":
				$query2 = $this->link->prepare("SELECT `cid` FROM `".$prefix."course_student` WHERE `csid`=?");
				$values = array($id);
				$query2->execute($values);
				$result2 = $query2->fetchAll();
				return $this->StudentAccessCheck("cid",$result2[0]['cid'],$scode);
				$query = $this->link->prepare("SELECT `admin_level` FROM `".$prefix."homeworks_admins` INNER JOIN `".$prefix."course_student` ON `".$prefix."homeworks_admins`.`csid`=`".$prefix."course_student`.`csid` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` WHERE `".$prefix."course_student`.`csid`=? AND `".$prefix."students`.`scode`=?");
				$values = array($id,$scode);
				$query->execute($values);
			break;
			case "hid":
				$query = $this->link->prepare("SELECT * FROM `".$prefix."homeworks` WHERE `hid`=?");
				$values = array($id);
				$query->execute($values);
				$result = $query->fetchAll();
				if($result[0]['cid']==NULL)
					return $this->StudentAccessCheck("csid",$result[0]['csid'],$scode);
				else if($result[0]['csid']==NULL)
					return $this->StudentAccessCheck("cid",$result[0]['cid'],$scode);
			break;
		}
		$counts = $query->rowCount();
		if($counts==0)
			return 0; //No Access
		else
		{
			$result = $query->fetchAll();
			return $result[0]['admin_level'];
		}
	}
	
	function CheckStudentPermissionBySID($sid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT `admin_level` FROM `".$prefix."homeworks_admins` INNER JOIN `".$prefix."course_student` ON `".$prefix."homeworks_admins`.`csid`=`".$prefix."course_student`.`csid` WHERE `".$prefix."course_student`.`sid`=? AND (`".$prefix."homeworks_admins`.`admin_level`=1 OR `".$prefix."homeworks_admins`.`admin_level`=2)");
		$values = array($sid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==0)
			return 0;
		else
		{
			$result = $query->fetchAll();
			return $result[0]['admin_level'];
		}
	}
	
	function SetStudentPermission($csid,$admin_level)
	{
		global $prefix;
		if($admin_level==NULL)
		{
			$query = $this->link->prepare("DELETE FROM `".$prefix."homeworks_admins` WHERE `csid`=?");
			$values = array($csid);
			$query->execute($values);
		}
		else
		{
			$query = $this->link->prepare("DELETE FROM `".$prefix."homeworks_admins` WHERE `csid`=?");
			$values = array($csid);
			$query->execute($values);
			$query->execute();
			$query = $this->link->prepare("INSERT INTO `".$prefix."homeworks_admins` (csid,admin_level)
		VALUES (?,?)
		");
		$values = array($csid,$admin_level);
		$query->execute($values);
		}
		return $query->rowCount();
		
	}
	
	function RemoveInvalidExtentions($ext)
	{
		$ext = str_replace(' ','',$ext);
		global $invalid_extensions;
		$invalid_extensions2 = explode(',',$invalid_extensions);
		$ext2 = explode(',',$ext);
		$ext3 ="";
		foreach($ext2 as $ext4)
		{
			if(!in_array($ext4,$invalid_extensions2))
			{
				$ext3.=$ext4.',';
			}
		}
		$ext3 = substr($ext3,0,-1);
		return $ext3;
	}
	
	
	function UpdateStudentHomeworkStatus($hid,$csid,$hdstatus,$hdscore,$teacher_comment)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."homeworks_done` SET `hdstatus`=?, `hdscore`=?, `teacher_comment`=? WHERE `hid`=? AND `csid`=?");
		$values = array($hdstatus,$hdscore,$teacher_comment,$hid,$csid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function CheckHomeworkFile($file)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."homeworks_done` WHERE `file_name`='$file'");
		$count = $query->rowCount();
		return $count;
	}
	
}

?>
