<?php
include_once('class.database.php');
class ManageLessons
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddLesson($lcode,$lname,$factor,$eff_on_term_avg,$eff_on_total_avg,$lcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("INSERT INTO `".$prefix."lessons` (`lcode`,`lname`,`factor`,`eff_on_term_avg`,`eff_on_total_avg`,`lcomment`,`admin_id`)
		VALUES (?,?,?,?,?,?,?)
		");
		$values = array($lcode,$lname,$factor,$eff_on_term_avg,$eff_on_total_avg,$lcomment,$admin_id);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateLesson($lid,$lcode,$lname,$factor,$eff_on_term_avg,$eff_on_total_avg,$lcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."lessons` SET `lcode`=?, `lname`=?, `factor`=?,`eff_on_term_avg`=?, `eff_on_total_avg`=?, `lcomment`=?, `admin_id`=? WHERE `lid`=?");
		$values = array($lcode,$lname,$factor,$eff_on_term_avg,$eff_on_total_avg,$lcomment,$admin_id,$lid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function GetLessonList($query)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."lessons` $query ORDER BY `lid` DESC");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetLessonList2($query,$start,$limit)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."lessons` $query ORDER BY `lid` DESC LIMIT $start,$limit");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	
	function GetLessonInfo($lcode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."lessons` WHERE `lcode`=?");
		$values = array($lcode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function LCodeAvailability($lcode)
	{
		global $prefix;
		if(preg_match('/^[a-z\d_]{1,50}$/i', $lcode))
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."lessons` WHERE `lcode`=?");
			$values = array($lcode);
			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 0;			
			else
				return 1;
		}
		else
		{
			return 2;
		}
		
	}
	
	function GetLessonInfoById($lid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."lessons` WHERE `lid` =?");
		$values = array($lid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastLessonID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `lid` FROM `".$prefix."lessons` ORDER BY `lid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['lid'];	
	}
	
	function DeleteLesson($lid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."lessons` WHERE `lid`=?");
		$values = array($lid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
}
?>
