<?php
include_once('class.database.php');
class ManageStudents
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddStudent($scode,$spass,$sfname,$slname,$sgender,$sstatus,$sfaname,$sbirthdate,$scardid,$scard_place,$sdegree,$smajor,$saddress,$szipcode,$stel,$smobile,$semail,$spic,$scomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("INSERT INTO `".$prefix."students` (`scode`,`spass`,`sfname`,`slname`,`sgender`,`sstatus`,`sfaname`,`sbirthdate`,`scardid`,`scard_place`,`sdegree`,`smajor`,`saddress`,`szipcode`,`stel`,`smobile`,`semail`,`spic`,`scomment`,`admin_id`)
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)
		");
		$values = array($scode,$spass,$sfname,$slname,$sgender,$sstatus,$sfaname,$sbirthdate,$scardid,$scard_place,$sdegree,$smajor,$saddress,$szipcode,$stel,$smobile,$semail,$spic,$scomment,$admin_id);
		$query->execute($values);
		$counts = $query->rowCount();
		return $counts;
	}
	
	function UpdateStudent($sid,$scode,$sfname,$slname,$sgender,$sstatus,$sfaname,$sbirthdate,$scardid,$scard_place,$sdegree,$smajor,$saddress,$szipcode,$stel,$smobile,$semail,$spic,$scomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."students` SET `scode`=?, `sfname`=?, `slname`=?, `sgender`=?, `sstatus`=?, `sfaname`=?, `sbirthdate`=?, `scardid`=?, `scard_place`=?, `sdegree`=?, `smajor`=?, `saddress`=?, `szipcode`=?, `stel`=?, `smobile`=?, `semail`=?, `spic`=?, `scomment`=?, `admin_id`=? WHERE sid=?");
		$values = array($scode,$sfname,$slname,$sgender,$sstatus,$sfaname,$sbirthdate,$scardid,$scard_place,$sdegree,$smajor,$saddress,$szipcode,$stel,$smobile,$semail,$spic,$scomment,$admin_id,$sid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
		
	function GetStudentList($query)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."students` $query ORDER BY sid DESC");
		
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	function GetStudentList2($query,$start,$limit)
	{
		global $prefix;
		if($start==NULL && $limit==NULL)
			$query = $this->link->query("SELECT * FROM `".$prefix."students` $query ORDER BY sid DESC");
		else
			$query = $this->link->query("SELECT * FROM `".$prefix."students` $query ORDER BY sid DESC LIMIT $start,$limit");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LoginStudent($username,$password)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."students` WHERE `scode`=? AND `spass`=?");
		$values = array($username,$password);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;		
	}
	
	function GetUserInfo($username)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."students` WHERE `scode`=?");
		$values = array($scode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function UsernameAvailability($username)
	{
		global $prefix;
		if(preg_match('/^[a-z\d_]{1,50}$/i', $username))
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."students` WHERE `scode`=?");
			$values = array($username);
			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 0;			
			else
				return 1;
		}
		else
		{
			return 2;
		}
		
	}
	
	function GetStudentInfoById($sid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."students` WHERE `sid`=?");
		$values = array($sid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetStudentInfoBySCode($scode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."students` WHERE `scode`=?");
		$values = array($scode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastStudentID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `sid` FROM `".$prefix."students` ORDER BY `sid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['sid'];	
	}
	
	function DeleteStudent($sid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."students` WHERE `sid`=?");
		$values = array($sid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
	function ResetPassword($sid,$spass)
	{
		global $prefix;
		$spass = md5($spass);
		$query = $this->link->prepare("UPDATE `".$prefix."students` SET `spass`=? WHERE `sid`=?");
		$values = array($spass,$sid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function ChangePassword($sid,$current_pass,$new_pass)
	{
		global $prefix;
		$current_pass = md5($current_pass);
		$new_pass = md5($new_pass);
		$query = $this->link->prepare("SELECT * FROM `".$prefix."students` WHERE `sid`=? AND `spass`=?");
		$values = array($sid,$current_pass);
		$query->execute($values);
		
		$counts = $query->rowCount();
		if($counts==1)
		{
			$query = $this->link->prepare("UPDATE `".$prefix."students` SET `spass`=? WHERE `sid`=?");
			$values = array($new_pass,$sid);

			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 2;
			else
				return 3;
		}
		else
			return 1;
	}
	
	
	function GetStudentTermList($sid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."terms` WHERE `".$prefix."terms`.`tid` In
(SELECT `".$prefix."courses`.`tid` from `".$prefix."course_student` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid` = `".$prefix."terms`.`tid` WHERE `".$prefix."course_student`.`sid`=?) ORDER BY `".$prefix."terms`.`tid` DESC");
		$values = array($sid);
		$query->execute($values);
//		$query = $this->link->query("SELECT * FROM ".$prefix."students WHERE sid='$sid'");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	function GetStudentCourseList($sid,$tid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `".$prefix."course_student`.`sid`=? AND `".$prefix."terms`.`tid`=? ORDER BY `".$prefix."lessons`.`lname`");
		$values = array($sid,$tid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function CalculateAve($tid,$sid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT sum(`grade`*`factor`)/sum(`factor`) AS `ave` FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `".$prefix."course_student`.`sid`=? AND `".$prefix."terms`.`tid`=? AND `".$prefix."lessons`.`eff_on_term_avg`!=0 AND `grade`!='' ORDER BY `".$prefix."lessons`.`lname`");
		$values = array($sid,$tid);
		$query->execute($values);
		$result = $query->fetchAll();
		
		return round($result[0]['ave'],2);			
		
	}
	
	function CalculateTotalAve($sid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT sum(`grade`*`factor`)/sum(`factor`) AS `ave` FROM `".$prefix."course_student` INNER JOIN `".$prefix."students` ON `".$prefix."course_student`.`sid`=`".$prefix."students`.`sid` INNER JOIN `".$prefix."courses` ON `".$prefix."course_student`.`cid`=`".$prefix."courses`.`cid` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."teachers` ON `".$prefix."courses`.`pid`=`".$prefix."teachers`.`pid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `".$prefix."course_student`.`sid`=? AND `".$prefix."lessons`.`eff_on_total_avg`!=0 AND `grade`!='' ORDER BY `".$prefix."lessons`.`lname`");
		$values = array($sid);
		$query->execute($values);

		$result = $query->fetchAll();
		
		return round($result[0]['ave'],2);			
		
	}
	
	function DelPic($id)
	{
		global $prefix;
		global $pic_prefix;
		$studentInfo = $this->GetStudentInfoById($id);
		if(file_exists('../img/students/'.$pic_prefix.$studentInfo[0]['sid'].$studentInfo[0]['spic']))
		{
			if(unlink('../img/students/'.$pic_prefix.$studentInfo[0]['sid'].$studentInfo[0]['spic']))
				return 1;
			else
				return 0;
		}
		else
			return 1;
	}	
}

?>
