<?php
include_once('class.database.php');
class ManageTeachers
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddTeacher($pcode,$ppass,$pfname,$plname,$pgender,$pstatus,$pfaname,$pbirthdate,$pcardid,$pcard_place,$pdegree,$pmajor,$paddress,$pzipcode,$ptel,$pmobile,$pemail,$ppic,$paccount_number,$pcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("INSERT INTO `".$prefix."teachers` (`pcode`,`ppass`,`pfname`,`plname`,`pgender`,`pstatus`,`pfaname`,`pbirthdate`,`pcardid`,`pcard_place`,`pdegree`,`pmajor`,`paddress`,`pzipcode`,`ptel`,`pmobile`,`pemail`,`ppic`,`paccount_number`,`pcomment`,`admin_id`)
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)
		");
		$values = array($pcode,$ppass,$pfname,$plname,$pgender,$pstatus,$pfaname,$pbirthdate,$pcardid,$pcard_place,$pdegree,$pmajor,$paddress,$pzipcode,$ptel,$pmobile,$pemail,$ppic,$paccount_number,$pcomment,$admin_id);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateTeacher($pid,$pcode,$pfname,$plname,$pgender,$pstatus,$pfaname,$pbirthdate,$pcardid,$pcard_place,$pdegree,$pmajor,$paddress,$pzipcode,$ptel,$pmobile,$pemail,$ppic,$paccount_number,$pcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."teachers` SET `pcode`=?, `pfname`=?, `plname`=?, `pgender`=?, `pstatus`=?, `pfaname`=?, `pbirthdate`=?, `pcardid`=?, `pcard_place`=?, `pdegree`=?, `pmajor`=?, `paddress`=?, `pzipcode`=?, `ptel`=?, `pmobile`=?, `pemail`=?, `ppic`=?, `paccount_number`=?, `pcomment`=?, `admin_id`=? WHERE `pid`=?");
		$values = array($pcode,$pfname,$plname,$pgender,$pstatus,$pfaname,$pbirthdate,$pcardid,$pcard_place,$pdegree,$pmajor,$paddress,$pzipcode,$ptel,$pmobile,$pemail,$ppic,$paccount_number,$pcomment,$admin_id,$pid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function GetTeacherList($query)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."teachers` $query ORDER BY `pid` DESC");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetTeacherList2($query,$start,$limit)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."teachers` $query ORDER BY `pid` DESC LIMIT $start,$limit");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LoginTeacher($username,$password)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."teachers` WHERE `pcode`=? AND `ppass`=?");
		$values = array($username,$password);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;		
	}
	
	function GetUserInfo($username)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."teachers` WHERE p`code`=?");
		$values = array($username);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function UsernameAvailability($username)
	{
		global $prefix;
		if(preg_match('/^[a-z\d_]{1,50}$/i', $username))
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."teachers` WHERE `pcode`=?");
			$values = array($username);
			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 0;			
			else
				return 1;
		}
		else
		{
			return 2;
		}
		
	}
	
	function GetTeacherInfoById($pid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."teachers` WHERE `pid`=?");
		$values = array($pid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetTeacherInfoByPCode($pcode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."teachers` WHERE `pcode`=?");
		$values = array($pcode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastTeacherID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `pid` FROM `".$prefix."teachers` ORDER BY `pid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['pid'];	
	}
	
	function DeleteTeacher($pid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."teachers` WHERE `pid`=?");
		$values = array($pid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
	function ResetPassword($pid,$ppass)
	{
		global $prefix;
		$ppass = md5($ppass);
		$query = $this->link->prepare("UPDATE `".$prefix."teachers` SET `ppass`=? WHERE `pid` =?");
		$values = array($ppass,$pid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function ChangePassword($pid,$current_pass,$new_pass)
	{
		global $prefix;
		$current_pass = md5($current_pass);
		$new_pass = md5($new_pass);
		$query = $this->link->prepare("SELECT * FROM `".$prefix."teachers` WHERE `pid`=? AND `ppass`=?");
		$values = array($pid,$current_pass);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$query = $this->link->prepare("UPDATE `".$prefix."teachers` SET `ppass`=? WHERE `pid`=?");
			$values = array($new_pass,$pid);

			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 2;
			else
				return 3;
		}
		else
			return 1;
	}
	
	function GetTeacherTermList($pid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."terms` WHERE `".$prefix."terms`.`tid` In
(SELECT `".$prefix."courses`.`tid` from `".$prefix."courses` WHERE `".$prefix."courses`.`pid`=?) ORDER BY `".$prefix."terms`.`tid` DESC");
		$values = array($pid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetTeacherCourseList($pid,$tid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."courses` INNER JOIN `".$prefix."classes` ON `".$prefix."courses`.`clid`=`".$prefix."classes`.`clid` INNER JOIN `".$prefix."lessons` ON `".$prefix."courses`.`lid`=`".$prefix."lessons`.`lid` INNER JOIN `".$prefix."terms` ON `".$prefix."courses`.`tid`=`".$prefix."terms`.`tid` WHERE `".$prefix."courses`.`pid`=? AND `".$prefix."courses`.`tid`=? ORDER BY `".$prefix."lessons`.`lname`");
		$values = array($pid,$tid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function DelPic($id)
	{
		global $prefix;
		global $pic_prefix;
		$teacherInfo = $this->GetTeacherInfoById($id);
		if(file_exists('../img/teachers/'.$pic_prefix.$teacherInfo[0]['pid'].$teacherInfo[0]['ppic']))
		{
			if(unlink('../img/teachers/'.$pic_prefix.$teacherInfo[0]['pid'].$teacherInfo[0]['ppic']))
				return 1;
			else
				return 0;
		}
		else
			return 1;
	}
	
}

?>
