<?php
include_once('class.database.php');
class ManageTerms
{
	public $link;
	
	function __construct()
	{
		global $prefix;
		$db_connection = new dbConnection();
		$this->link = $db_connection->connect();
		
		return $this->link;		
	}
	
	function AddTerm($tcode,$tname,$tcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("INSERT INTO `".$prefix."terms` (`tcode`,`tname`,`tcomment`,`admin_id`)
		VALUES (?,?,?,?)
		");
		$values = array($tcode,$tname,$tcomment,$admin_id);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function UpdateTerm($tid,$tcode,$tname,$tcomment,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."terms` SET `tcode`=?, `tname`=?, `tcomment`=?, `admin_id`=? WHERE `tid`=?");
		$values = array($tcode,$tname,$tcomment,$admin_id,$tid);
		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;
	}
	
	function GetTermList($query)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."terms` $query ORDER BY `tid` DESC");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function GetTermList2($query,$start,$limit)
	{
		global $prefix;
		$query = $this->link->query("SELECT * FROM `".$prefix."terms` $query ORDER BY `tid` DESC LIMIT $start,$limit");
		$counts = $query->rowCount();
		if($counts>=1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}

	
	function GetTermInfo($tcode)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."terms` WHERE tcode=?");
		$values = array($tcode);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
		
	}
	
	function TCodeAvailability($tcode)
	{
		global $prefix;
		if(preg_match('/^[a-z\d_]{1,50}$/i', $tcode))
		{
			$query = $this->link->prepare("SELECT * FROM `".$prefix."terms` WHERE `tcode`=?");
			$values = array($tcode);
			$query->execute($values);
			$counts = $query->rowCount();
			if($counts==1)
				return 0;			
			else
				return 1;
		}
		else
		{
			return 2;
		}
		
	}
	
	function GetTermInfoById($tid)
	{
		global $prefix;
		$query = $this->link->prepare("SELECT * FROM `".$prefix."terms` WHERE `tid`=?");
		$values = array($tid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
		{
			$result = $query->fetchAll();
			
			return $result;			
		}
		else
		{
			return $counts;
		}
	}
	
	function LastTermID()
	{
		global $prefix;
		$query = $this->link->query("SELECT `tid` FROM `".$prefix."terms` ORDER BY `tid` DESC LIMIT 0,1");
		$result = $query->fetchAll();
		return $result[0]['tid'];	
	}
	
	function DeleteTerm($tid)
	{
		global $prefix;
		$query = $this->link->prepare("DELETE FROM `".$prefix."terms` WHERE `tid`=?");
		$values = array($tid);
		$query->execute($values);
		$counts = $query->rowCount();
		if($counts==1)
			return 1;
		else		
			return $counts;		
	}
	
	function ActiveGrade($tid,$status,$admin_id)
	{
		global $prefix;
		$query = $this->link->prepare("UPDATE `".$prefix."terms` SET `grade_active`=?, `admin_id`=? WHERE `tid`=?");
		$values = array($status,$admin_id,$tid);

		$query->execute($values);
		$counts = $query->rowCount();
		
		return $counts;		
	}
	
}

?>
