<?php
require_once('../config.php');

//Protecting against SESSION Hijaking
ini_set('session.cookie_httponly',true);
session_start();
if(isset($_SESSION['teacher_last_ip'])===false)
{
	$_SESSION['teacher_last_ip'] = $_SERVER['REMOTE_ADDR'];
}
if($_SESSION['teacher_last_ip'] !== $_SERVER['REMOTE_ADDR'])
{
	session_unset();
	session_destroy();
}
//--End of Protecting against SESSION Hijaking



if (!isset($_SESSION[$teacher_session_name]) && !preg_match("/login.php/i", $_SERVER['REQUEST_URI']))
{
	$redirect = explode('/',$_SERVER['REQUEST_URI']);
	$redirect = $redirect[count($redirect)-1];
	if($redirect=="")
	{
		header("Location: login.php"); exit;
	}
	else
	{
		header("Location: login.php?redirect=".urlencode($redirect).""); exit;
	}
}

include_once('../include/class.database.php');
$db_connection = new dbConnection();
if($db_connection->connect()==0)
	header('Location: ../install');
	
include_once('../include/class.settings.php');
$settings = new ManageSettings();
$system_settings = $settings->SystemSettings();

$dir = $system_settings[0]["dir"];
$theme = $system_settings[0]["theme"];
$lang = $system_settings[0]["lang"];
$jamaa_active = $system_settings[0]["jamaa_active"];
$files_final_size = $system_settings[0]["files_final_size"];
$bulk_email = $system_settings[0]["bulk_email"];
$system_title = $system_settings[0]["system_title"];
$institute_name = $system_settings[0]["institute_name"];
$teachers_message = $system_settings[0]["teachers_message"];

if ($dir =="rtl")
{
	$align1 = "right";
	$align2 = "left";
}
else
{
	$align1 = "left";
	$align2 = "right";
}

$invalid_extensions = "exe,htm,html,php,asp,aspx,pl";

include_once('../include/jdf.php');
include_once('../lang/'.$lang.'.php');
include_once('../include/class.admin.php');
include_once('../include/class.student.php');
include_once('../include/class.teacher.php');
include_once('../include/class.term.php');
include_once('../include/class.class.php');
include_once('../include/class.lesson.php');
include_once('../include/class.course.php');
include_once('../include/class.course-student.php');
include_once('../include/class.objection.php');
include_once('../include/class.homework.php');


if(isset($_SESSION[$teacher_session_name]))
{
	$CheckCookieForTeacher = new ManageTeachers();
	if(!$CheckCookieForTeacher->LoginTeacher($_SESSION[$teacher_session_name],$_SESSION[$teacher_password_session_name]))
	{
		unset($CheckCookieForTeacher);
		header ('Location: logout.php');
	}
		
}
?>